#ifndef OSM_DRAW_H
#define OSM_DRAW_H

struct rnd_xform_s {
	double zoom_mpp;
};

void osm_expose_main(rnd_hid_t *hid, const rnd_hid_expose_ctx_t *region, rnd_xform_t *xform_caller);
void osm_expose_preview(rnd_hid_t *hid, rnd_hid_expose_ctx_t *e);

/* Temporarily inhibid drawing if this is non-zero. A function that calls a
   lot of other functions that would call osm_draw() a lot in turn may increase
   this value before the calls, then decrease it at the end and call osm_draw().
   This makes sure the whole block is redrawn only once at the end. */
extern rnd_cardinal_t osm_draw_inhibit;

#define osm_draw_inhibit_inc() osm_draw_inhibit++
#define osm_draw_inhibit_dec() \
do { \
	if (osm_draw_inhibit > 0) \
		osm_draw_inhibit--; \
} while(0) \


#endif
