/*
 *                            COPYRIGHT
 *
 *  osm-rnd - OpenStreetMap editor/viewer
 *  Copyright (C) 2023 Tibor 'Igor2' Palinkas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Contact:
 *    Project page: http://repo.hu/projects/osm-rnd
 *    lead developer: http://repo.hu/projects/osm-rnd/contact.html
 *    mailing list: (not yet)
 */

#ifndef OSM_SEARCH_H
#define OSM_SEARCH_H

#define osm_slop (rnd_gui->coord_per_pix*4)

osm_any_obj_t *osm_search_obj_xy(osm_layer_t *layer, rnd_coord_t x, rnd_coord_t y);
osm_any_obj_t *osm_search_obj_xy_unsel(osm_layer_t *ly, rnd_coord_t x, rnd_coord_t y);
osm_any_obj_t *osm_search_obj_xy_mask(osm_layer_t *ly, rnd_coord_t x, rnd_coord_t y, osm_objtype_mask_t mask);

void osm_search_append_objs_box(vtp0_t *dst, osm_layer_t *layer, const osm_rtree_box_t *box);
void osm_search_append_objs_box_mask(vtp0_t *dst, osm_layer_t *ly, const osm_rtree_box_t *box, osm_objtype_mask_t mask);
void osm_search_append_objs_xy(vtp0_t *dst, osm_layer_t *layer, rnd_coord_t x, rnd_coord_t y);
void osm_search_append_objs_xy_mask(vtp0_t *dst, osm_layer_t *ly, rnd_coord_t x, rnd_coord_t y, osm_objtype_mask_t mask);

long osm_search_all_selected(vtp0_t *dst, osm_layer_t *ly);
long osm_search_all_selected_mask(vtp0_t *dst, osm_layer_t *ly, osm_objtype_mask_t mask);

/* Callback based referer search */

typedef void (*osm_referer_relation_cb)(void *uctx, osm_relation_t *rel, long member_idx);
void osm_search_referer_relations(osm_any_obj_t *obj, osm_referer_relation_cb cb, void *uctx);
rnd_bool osm_search_has_referer_relations(osm_any_obj_t *obj);


typedef void (*osm_referer_way_cb)(void *uctx, osm_way_t *way, long member_idx);
void osm_search_referer_ways(osm_node_t *node, osm_referer_way_cb cb, void *uctx);
rnd_bool osm_search_has_referer_way(osm_node_t *nd);


#endif
