/* Load an osm xml file from fn into layer ly; if ly is NULL, use or allocate
   layer using the file name */
int osm_oxml_load_into(osm_design_t *osm, const char *fn, osm_layer_t **ly);

/* Print the an object (anything between the <object></object> pair)
   in xml format to f. If changeset_id is not NULL, override object's
   own changeset (useful when generating a diff with local edits) */
void osm_oxml_fprint_obj(FILE *f, const char *ind, const osm_any_obj_t *obj, const osm_id_t *changeset_id);


/* Load history of objets from fn to hst (updating an already existing hst) */
int osm_oxml_load_history(osm_history_t *hst, const char *fn);

/* Save all objects from history into a file that can be loaded again later
   (useful for debugging) */
int osm_oxml_save_history(osm_design_t *osm, osm_history_t *hst, const char *fn);

/* Load a single changeset from an xml file (e.g. after downloading it
   from the osm server for history) */
int osm_oxml_load_changeset(osm_history_t *hst, const char *fn);
